interface GmPreset {
    op1Type: "sawtooth" | "sine" | "square" | "triangle";
    op2Type: "sawtooth" | "sine" | "square" | "triangle";
    gain: number;
    op1Dest: "op2" | "out";
    op2Dest: "op1" | "out";
    op1Ratio: number;
    op2Ratio: number;
}
export declare class GmPlayer {
    private readonly context;
    private readonly op1;
    private readonly op2;
    private readonly gain;
    private op1Ratio;
    private op2Ratio;
    constructor();
    programChange(instrument: number): void;
    changeInstrument(preset: GmPreset): void;
    play(freq: number): void;
    stop(freq: number): void;
}
export {};
