"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KEY_BACKSLASH = exports.KEY_B = exports.KEY_ASTERISK = exports.KEY_ALTGR = exports.KEY_ALT = exports.KEY_A = exports.KEY_9_PAD = exports.KEY_9 = exports.KEY_8_PAD = exports.KEY_8 = exports.KEY_7_PAD = exports.KEY_7 = exports.KEY_6_PAD = exports.KEY_6 = exports.KEY_5_PAD = exports.KEY_5 = exports.KEY_4_PAD = exports.KEY_4 = exports.KEY_3_PAD = exports.KEY_3 = exports.KEY_2_PAD = exports.KEY_2 = exports.KEY_1_PAD = exports.KEY_1 = exports.KEY_0_PAD = exports.KEY_0 = exports.key_led_flag = exports.three_finger_flag = exports.clear_keybuf = exports.set_keyboard_rate = exports.set_leds = exports.keyboard_lowlevel_callback = exports.keyboard_ucallback = exports.keyboard_callback = exports.simulate_ukeypress = exports.simulate_keypress = exports.scancode_to_name = exports.scancode_to_ascii = exports.ureadkey = exports.readkey = exports.keypressed = exports.key_shifts = exports.key_buffer = exports.key = exports.keyboard_needs_poll = exports.poll_keyboard = exports.install_keyboard_hooks = exports.remove_keyboard = exports.install_keyboard = exports.keyboard_driver = void 0;
exports.KEY_OPENBRACE = exports.KEY_O = exports.KEY_NUMLOCK = exports.KEY_N = exports.KEY_MINUS_PAD = exports.KEY_MINUS = exports.KEY_MENU = exports.KEY_MAX = exports.KEY_M = exports.KEY_LWIN = exports.KEY_LSHIFT = exports.KEY_LEFT = exports.KEY_LCONTROL = exports.KEY_L = exports.KEY_K = exports.KEY_J = exports.KEY_INSERT = exports.KEY_I = exports.KEY_HOME = exports.KEY_H = exports.KEY_G = exports.KEY_F9 = exports.KEY_F8 = exports.KEY_F7 = exports.KEY_F6 = exports.KEY_F5 = exports.KEY_F4 = exports.KEY_F3 = exports.KEY_F2 = exports.KEY_F12 = exports.KEY_F11 = exports.KEY_F10 = exports.KEY_F1 = exports.KEY_F = exports.KEY_ESC = exports.KEY_EQUALS_PAD = exports.KEY_EQUALS = exports.KEY_ENTER_PAD = exports.KEY_ENTER = exports.KEY_END = exports.KEY_E = exports.KEY_DOWN = exports.KEY_DEL = exports.KEY_D = exports.KEY_COMMA = exports.KEY_COLON = exports.KEY_CLOSEBRACE = exports.KEY_CAPSLOCK = exports.KEY_C = exports.KEY_BACKSPACE = void 0;
exports._keyboard_loop = exports._default_enabled_keys = exports._keyboard_installed = exports.KB_SHIFT_FLAG = exports.KB_SCROLOCK_FLAG = exports.KB_RWIN_FLAG = exports.KB_NUMLOCK_FLAG = exports.KB_MENU_FLAG = exports.KB_LWIN_FLAG = exports.KB_INALTSEQ_FLAG = exports.KB_CTRL_FLAG = exports.KB_COMMAND_FLAG = exports.KB_CAPSLOCK_FLAG = exports.KB_ALT_FLAG = exports.KB_ACCENT4_FLAG = exports.KB_ACCENT3_FLAG = exports.KB_ACCENT2_FLAG = exports.KB_ACCENT1_FLAG = exports.KEY_Z = exports.KEY_Y = exports.KEY_X = exports.KEY_W = exports.KEY_V = exports.KEY_UP = exports.KEY_U = exports.KEY_TILDE = exports.KEY_TAB = exports.KEY_T = exports.KEY_STOP = exports.KEY_SPACE = exports.KEY_SLASH_PAD = exports.KEY_SLASH = exports.KEY_SCRLOCK = exports.KEY_S = exports.KEY_RWIN = exports.KEY_RSHIFT = exports.KEY_RIGHT = exports.KEY_RCONTROL = exports.KEY_R = exports.KEY_QUOTE = exports.KEY_Q = exports.KEY_PRTSCR = exports.KEY_PLUS_PAD = exports.KEY_PGUP = exports.KEY_PGDN = exports.KEY_PAUSE = exports.KEY_P = void 0;
var debug_1 = require("./debug");
var timer_1 = require("./timer");
exports.keyboard_driver = {
    id: 0,
    name: "Browser Keyboard",
    desc: " Browser Keyboard",
    ascii_name: "Browser Keyboard",
};
function install_keyboard(enable_keys) {
    if (exports._keyboard_installed) {
        debug_1._allog("Keyboard already installed");
        return -1;
    }
    if (enable_keys) {
        _enabled_keys = enable_keys;
    }
    else {
        _enabled_keys = exports._default_enabled_keys;
    }
    for (var c = 0; c < 0x80; c += 1) {
        exports.key[c] = false;
    }
    document.addEventListener("keyup", _keyup);
    document.addEventListener("keydown", _keydown);
    exports._keyboard_installed = true;
    debug_1.log("Keyboard installed!");
    return 0;
}
exports.install_keyboard = install_keyboard;
function remove_keyboard() {
    if (!exports._keyboard_installed) {
        debug_1._allog("Keyboard not installed");
        return -1;
    }
    document.removeEventListener("keyup", _keyup);
    document.removeEventListener("keydown", _keydown);
    exports._keyboard_installed = false;
    debug_1.log("Keyboard removed!");
    return 0;
}
exports.remove_keyboard = remove_keyboard;
function install_keyboard_hooks(keypressed, readkey) {
    void keypressed;
    void readkey;
}
exports.install_keyboard_hooks = install_keyboard_hooks;
function poll_keyboard() {
    return 0;
}
exports.poll_keyboard = poll_keyboard;
function keyboard_needs_poll() {
    return false;
}
exports.keyboard_needs_poll = keyboard_needs_poll;
exports.key = [];
exports.key_buffer = [];
exports.key_shifts = 0;
function keypressed() {
    return exports.key_buffer.length > 0;
}
exports.keypressed = keypressed;
function readkey() {
    return __awaiter(this, void 0, void 0, function () {
        var top;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(exports.key_buffer.length === 0)) return [3, 2];
                    return [4, timer_1.rest(5)];
                case 1:
                    _a.sent();
                    return [3, 0];
                case 2:
                    top = exports.key_buffer.pop();
                    if (typeof top === "number") {
                        return [2, top];
                    }
                    return [2, -1];
            }
        });
    });
}
exports.readkey = readkey;
function ureadkey(scancode) {
    void scancode;
    return 0;
}
exports.ureadkey = ureadkey;
function scancode_to_ascii(scancode) {
    return scancode;
}
exports.scancode_to_ascii = scancode_to_ascii;
function scancode_to_name(scancode) {
    return scancode;
}
exports.scancode_to_name = scancode_to_name;
function simulate_keypress(key) {
    _keydown_handler(key);
}
exports.simulate_keypress = simulate_keypress;
function simulate_ukeypress(key, scancode) {
    void scancode;
    _keydown_handler(key);
}
exports.simulate_ukeypress = simulate_ukeypress;
function keyboard_callback(key) {
    void key;
}
exports.keyboard_callback = keyboard_callback;
function keyboard_ucallback(key, scancode) {
    void key;
    void scancode;
}
exports.keyboard_ucallback = keyboard_ucallback;
function keyboard_lowlevel_callback(key) {
    void key;
}
exports.keyboard_lowlevel_callback = keyboard_lowlevel_callback;
function set_leds(leds) {
    void leds;
}
exports.set_leds = set_leds;
function set_keyboard_rate(delay, repeat) {
    void delay;
    void repeat;
}
exports.set_keyboard_rate = set_keyboard_rate;
function clear_keybuf() {
    exports.key_buffer.length = 0;
}
exports.clear_keybuf = clear_keybuf;
exports.three_finger_flag = false;
exports.key_led_flag = false;
exports.KEY_0 = 0x30, exports.KEY_0_PAD = 0x60, exports.KEY_1 = 0x31, exports.KEY_1_PAD = 0x61, exports.KEY_2 = 0x32, exports.KEY_2_PAD = 0x62, exports.KEY_3 = 0x33, exports.KEY_3_PAD = 0x63, exports.KEY_4 = 0x34, exports.KEY_4_PAD = 0x64, exports.KEY_5 = 0x35, exports.KEY_5_PAD = 0x65, exports.KEY_6 = 0x36, exports.KEY_6_PAD = 0x66, exports.KEY_7 = 0x37, exports.KEY_7_PAD = 0x67, exports.KEY_8 = 0x38, exports.KEY_8_PAD = 0x68, exports.KEY_9 = 0x39, exports.KEY_9_PAD = 0x69, exports.KEY_A = 0x41, exports.KEY_ALT = 0x12, exports.KEY_ALTGR = 0x12, exports.KEY_ASTERISK = 0x6a, exports.KEY_B = 0x42, exports.KEY_BACKSLASH = 0xdc, exports.KEY_BACKSPACE = 0x08, exports.KEY_C = 0x43, exports.KEY_CAPSLOCK = 0x14, exports.KEY_CLOSEBRACE = 0xdd, exports.KEY_COLON = 0xba, exports.KEY_COMMA = 0xbc, exports.KEY_D = 0x44, exports.KEY_DEL = 0x2e, exports.KEY_DOWN = 0x28, exports.KEY_E = 0x45, exports.KEY_END = 0x23, exports.KEY_ENTER = 0x0d, exports.KEY_ENTER_PAD = 0x0d, exports.KEY_EQUALS = 0xbb, exports.KEY_EQUALS_PAD = 0x0c, exports.KEY_ESC = 0x1b, exports.KEY_F = 0x46, exports.KEY_F1 = 0x70, exports.KEY_F10 = 0x79, exports.KEY_F11 = 0x7a, exports.KEY_F12 = 0x7b, exports.KEY_F2 = 0x71, exports.KEY_F3 = 0x72, exports.KEY_F4 = 0x73, exports.KEY_F5 = 0x74, exports.KEY_F6 = 0x75, exports.KEY_F7 = 0x76, exports.KEY_F8 = 0x77, exports.KEY_F9 = 0x78, exports.KEY_G = 0x47, exports.KEY_H = 0x48, exports.KEY_HOME = 0x24, exports.KEY_I = 0x49, exports.KEY_INSERT = 0x2d, exports.KEY_J = 0x4a, exports.KEY_K = 0x4b, exports.KEY_L = 0x4c, exports.KEY_LCONTROL = 0x11, exports.KEY_LEFT = 0x25, exports.KEY_LSHIFT = 0x10, exports.KEY_LWIN = 0x5b, exports.KEY_M = 0x4d, exports.KEY_MAX = 0xdf, exports.KEY_MENU = 0x5d, exports.KEY_MINUS = 0xbd, exports.KEY_MINUS_PAD = 0x6d, exports.KEY_N = 0x4e, exports.KEY_NUMLOCK = 0x90, exports.KEY_O = 0x4f, exports.KEY_OPENBRACE = 0xdb, exports.KEY_P = 0x50, exports.KEY_PAUSE = 0x13, exports.KEY_PGDN = 0x22, exports.KEY_PGUP = 0x21, exports.KEY_PLUS_PAD = 0x6b, exports.KEY_PRTSCR = 0x2c, exports.KEY_Q = 0x51, exports.KEY_QUOTE = 0xde, exports.KEY_R = 0x52, exports.KEY_RCONTROL = 0x11, exports.KEY_RIGHT = 0x27, exports.KEY_RSHIFT = 0x10, exports.KEY_RWIN = 0x5c, exports.KEY_S = 0x53, exports.KEY_SCRLOCK = 0x9d, exports.KEY_SLASH = 0xbf, exports.KEY_SLASH_PAD = 0x6f, exports.KEY_SPACE = 0x20, exports.KEY_STOP = 0xbe, exports.KEY_T = 0x54, exports.KEY_TAB = 0x09, exports.KEY_TILDE = 0xc0, exports.KEY_U = 0x55, exports.KEY_UP = 0x26, exports.KEY_V = 0x56, exports.KEY_W = 0x57, exports.KEY_X = 0x58, exports.KEY_Y = 0x59, exports.KEY_Z = 0x5a;
exports.KB_ACCENT1_FLAG = 0x1000, exports.KB_ACCENT2_FLAG = 0x2000, exports.KB_ACCENT3_FLAG = 0x4000, exports.KB_ACCENT4_FLAG = 0x8000, exports.KB_ALT_FLAG = 0x0004, exports.KB_CAPSLOCK_FLAG = 0x0400, exports.KB_COMMAND_FLAG = 0x0040, exports.KB_CTRL_FLAG = 0x0002, exports.KB_INALTSEQ_FLAG = 0x0800, exports.KB_LWIN_FLAG = 0x0008, exports.KB_MENU_FLAG = 0x0020, exports.KB_NUMLOCK_FLAG = 0x0200, exports.KB_RWIN_FLAG = 0x0010, exports.KB_SCROLOCK_FLAG = 0x0100, exports.KB_SHIFT_FLAG = 0x0001;
exports._keyboard_installed = false;
exports._default_enabled_keys = [
    exports.KEY_F1,
    exports.KEY_F2,
    exports.KEY_F3,
    exports.KEY_F4,
    exports.KEY_F5,
    exports.KEY_F6,
    exports.KEY_F7,
    exports.KEY_F8,
    exports.KEY_F9,
    exports.KEY_F10,
    exports.KEY_F11,
    exports.KEY_F12,
    exports.KEY_ESC,
];
var _enabled_keys = [];
function _keyboard_loop() {
    if (exports._keyboard_installed) {
    }
}
exports._keyboard_loop = _keyboard_loop;
function _keydown(e) {
    _keydown_handler(e.keyCode);
    if (!_enabled_keys.includes(e.keyCode))
        e.preventDefault();
}
function _keydown_handler(keyCode) {
    exports.key[keyCode] = true;
    exports.key_buffer.push(keyCode << 8);
    switch (keyCode) {
        case exports.KEY_LSHIFT:
        case exports.KEY_RSHIFT:
            exports.key_shifts |= exports.KB_SHIFT_FLAG;
            break;
        case exports.KEY_LCONTROL:
        case exports.KEY_RCONTROL:
            exports.key_shifts |= exports.KB_CTRL_FLAG;
            break;
        case exports.KEY_ALT:
            exports.key_shifts |= exports.KB_ALT_FLAG;
            break;
        case exports.KEY_LWIN:
            exports.key_shifts |= exports.KB_LWIN_FLAG;
            break;
        case exports.KEY_RWIN:
            exports.key_shifts |= exports.KB_RWIN_FLAG;
            break;
        case exports.KEY_MENU:
            exports.key_shifts |= exports.KB_MENU_FLAG;
            break;
        case exports.KEY_SCRLOCK:
            exports.key_shifts |= exports.KB_SCROLOCK_FLAG;
            break;
        case exports.KEY_NUMLOCK:
            exports.key_shifts |= exports.KB_NUMLOCK_FLAG;
            break;
        case exports.KEY_CAPSLOCK:
            exports.key_shifts |= exports.KB_CAPSLOCK_FLAG;
            break;
        default:
            break;
    }
}
function _keyup(e) {
    _keyup_handler(e.keyCode);
    if (!_enabled_keys.includes(e.keyCode))
        e.preventDefault();
}
function _keyup_handler(keyCode) {
    exports.key[keyCode] = false;
    switch (keyCode) {
        case exports.KEY_LSHIFT:
        case exports.KEY_RSHIFT:
            exports.key_shifts ^= exports.KB_SHIFT_FLAG;
            break;
        case exports.KEY_LCONTROL:
        case exports.KEY_RCONTROL:
            exports.key_shifts ^= exports.KB_CTRL_FLAG;
            break;
        case exports.KEY_ALT:
            exports.key_shifts ^= exports.KB_ALT_FLAG;
            break;
        case exports.KEY_LWIN:
            exports.key_shifts ^= exports.KB_LWIN_FLAG;
            break;
        case exports.KEY_RWIN:
            exports.key_shifts ^= exports.KB_RWIN_FLAG;
            break;
        case exports.KEY_MENU:
            exports.key_shifts ^= exports.KB_MENU_FLAG;
            break;
        case exports.KEY_SCRLOCK:
            exports.key_shifts ^= exports.KB_SCROLOCK_FLAG;
            break;
        case exports.KEY_NUMLOCK:
            exports.key_shifts ^= exports.KB_NUMLOCK_FLAG;
            break;
        case exports.KEY_CAPSLOCK:
            exports.key_shifts ^= exports.KB_CAPSLOCK_FLAG;
            break;
        default:
            break;
    }
}
//# sourceMappingURL=keyboard.js.map