"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scaleclamp = exports.abs = exports.frand = exports.rand32 = exports.AL_RAND = exports.rand = exports.floor = exports.fix_to_rad = exports.PI_4 = exports.PI_3 = exports.PI_2 = exports.PI2 = exports.PI = void 0;
exports.PI = 3.14159265;
exports.PI2 = 2 * 3.14159265;
exports.PI_2 = 3.14159265 / 2;
exports.PI_3 = 3.14159265 / 3;
exports.PI_4 = 3.14159265 / 4;
function fix_to_rad(d) {
    var deg = d * (360.0 / 256.0);
    return (-deg * exports.PI) / 180.0;
}
exports.fix_to_rad = fix_to_rad;
function floor(num) {
    return Math.floor(num);
}
exports.floor = floor;
function rand() {
    return Math.floor(65536 * Math.random());
}
exports.rand = rand;
function AL_RAND() {
    return rand();
}
exports.AL_RAND = AL_RAND;
function rand32() {
    return rand() | (rand() << 16);
}
exports.rand32 = rand32;
function frand() {
    return Math.random();
}
exports.frand = frand;
function abs(a) {
    return a < 0 ? -a : a;
}
exports.abs = abs;
function scaleclamp(value, min, max, min2, max2) {
    var cmp_val = min2 + ((value - min) / (max - min)) * (max2 - min2);
    if (max2 > min2) {
        cmp_val = cmp_val < max2 ? cmp_val : max2;
        return cmp_val > min2 ? cmp_val : min2;
    }
    cmp_val = cmp_val < min2 ? cmp_val : min2;
    return cmp_val > max2 ? cmp_val : max2;
}
exports.scaleclamp = scaleclamp;
//# sourceMappingURL=math.js.map