import { BITMAP } from "./types";
export declare function blit(source: BITMAP | undefined, dest: BITMAP | undefined, source_x: number, source_y: number, dest_x: number, dest_y: number, width: number, height: number): void;
export declare function stretch_blit(source: BITMAP | undefined, dest: BITMAP | undefined, source_x: number, source_y: number, source_width: number, source_height: number, dest_x: number, dest_y: number, dest_width: number, dest_height: number): void;
export declare function masked_blit(sprite: BITMAP | undefined, dest: BITMAP | undefined, source_x: number, source_y: number, dest_x: number, dest_y: number, width: number, height: number): void;
export declare function masked_stretch_blit(sprite: BITMAP | undefined, dest: BITMAP | undefined, source_x: number, source_y: number, source_w: number, source_h: number, dest_x: number, dest_y: number, dest_w: number, dest_h: number): void;
export declare function draw_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number): void;
export declare function stretch_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, w: number, h: number): void;
export declare function draw_sprite_v_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number): void;
export declare function draw_sprite_h_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number): void;
export declare function draw_sprite_vh_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number): void;
export declare function draw_trans_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number): void;
export declare function draw_lit_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, color: number): void;
export declare function draw_gouraud_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, c1: number, c2: number, c3: number, c4: number): void;
export declare function draw_character_ex(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, color: number, bg: number): void;
export declare function rotate_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, angle: number): void;
export declare function rotate_sprite_v_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, angle: number): void;
export declare function rotate_scaled_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, angle: number, scale: number): void;
export declare function rotate_scaled_sprite_v_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, angle: number, scale: number): void;
export declare function pivot_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, cx: number, cy: number, angle: number): void;
export declare function pivot_sprite_v_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, cx: number, cy: number, angle: number): void;
export declare function pivot_scaled_sprite(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, cx: number, cy: number, angle: number, scale: number): void;
export declare function pivot_scaled_sprite_v_flip(bmp: BITMAP | undefined, sprite: BITMAP | undefined, x: number, y: number, cx: number, cy: number, angle: number, scale: number): void;
