import { TIMER } from "./types";
export declare const timer_driver: {
    id: number;
    name: string;
    desc: string;
    ascii_name: string;
};
export declare function install_timer(): number;
export declare function remove_timer(): void;
export declare function install_int(proc: () => void, speed: number): void;
export declare function SECS_TO_TIMER(secs: number): number;
export declare function MSEC_TO_TIMER(msec: number): number;
export declare function BPS_TO_TIMER(bps: number): number;
export declare function BPM_TO_TIMER(bpm: number): number;
export declare function install_int_ex(proc: () => void, speed: number): void;
export declare function LOCK_VARIABLE(variable_name: number | string): void;
export declare function LOCK_FUNCTION(function_name: (...args: never) => void): void;
export declare function END_OF_FUNCTION(function_name: (...args: never) => void): void;
export declare function remove_int(proc: () => void): void;
export declare function install_param_int(procedure: () => void, param: string, speed: number): void;
export declare function install_param_int_ex(procedure: () => void, param: string, speed: number): void;
export declare function remove_param_int(proc: () => void, param: string): void;
export declare let retrace_count: number;
export declare function rest(time: number): Promise<void>;
export declare function rest_callback(time: number, callback?: () => void): Promise<void>;
export declare function _timer_lookup(proc: () => void): TIMER | -1;
