import { CONFIG_DATA } from "./types";
export declare function set_config_file(filename: string): void;
export declare function set_config_data(data: CONFIG_DATA, length: number): void;
export declare function override_config_data(data: CONFIG_DATA, length: number): void;
export declare function push_config_state(): void;
export declare function pop_config_state(): void;
export declare function flush_config_state(): void;
export declare function reload_config_texts(new_language: string): void;
export declare function hook_config_section(section: string, intgetter: (name: string, def: number) => void, stringgetter: (name: string, def: string) => void, stringsetter: (name: string, value: string) => void): void;
export declare function config_is_hooked(section: number): boolean;
export declare function get_config_string(section: string, name: string, def: string): string;
export declare function get_config_int(section: string, name: string, def: number): number;
export declare function get_config_hex(section: string, name: string, def: number): number;
export declare function get_config_float(section: string, name: string, def: number): number;
export declare function get_config_id(section: string, name: string, def: string): string;
export declare function get_config_argv(section: string, name: string): string[];
export declare function get_config_text(msg: string): string;
export declare function set_config_string(section: string, name: string, val: string): void;
export declare function set_config_int(section: string, name: string, val: number): void;
export declare function set_config_hex(section: string, name: string, val: number): void;
export declare function set_config_float(section: string, name: string, val: number): void;
export declare function set_config_id(section: string, name: string, val: number): void;
export declare function list_config_entries(section: string): string[];
export declare function list_config_sections(names: string[]): string[];
export declare function free_config_entries(names: string[]): void;
