import { BITMAP } from "./types";
export declare function clear_bitmap(bitmap: BITMAP | undefined): void;
export declare function clear_to_color(bitmap: BITMAP | undefined, colour: number): void;
export declare function putpixel(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function _putpixel(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function _putpixel15(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function _putpixel16(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function _putpixel24(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function _putpixel32(bmp: BITMAP | undefined, x: number, y: number, c: number): void;
export declare function getpixel(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function _getpixel(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function _getpixel15(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function _getpixel16(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function _getpixel24(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function _getpixel32(bmp: BITMAP | undefined, x: number, y: number): number;
export declare function vline(bitmap: BITMAP | undefined, x: number, y1: number, y2: number, colour: number): void;
export declare function hline(bitmap: BITMAP | undefined, x1: number, y: number, x2: number, colour: number): void;
export declare function do_line(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, d: number, proc: (bmp: BITMAP, x: number, y: number, d: number) => void): void;
export declare function line(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, colour: number): void;
export declare function fastline(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, colour: number): void;
export declare function triangle(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, colour: number): void;
export declare function polygon(bitmap: BITMAP | undefined, vertices: number, points: number[], colour: number): void;
export declare function rect(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, colour: number): void;
export declare function rectfill(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number, colour: number): void;
export declare function do_circle(bmp: BITMAP | undefined, x: number, y: number, radius: number, d: number, proc: (bmp: BITMAP, x: number, y: number, d: number) => void): void;
export declare function circle(bitmap: BITMAP | undefined, x: number, y: number, radius: number, colour: number): void;
export declare function circlefill(bitmap: BITMAP | undefined, x: number, y: number, radius: number, colour: number): void;
export declare function do_ellipse(bitmap: BITMAP | undefined, x: number, y: number, rx: number, ry: number, d: number, proc: (bmp: BITMAP, x: number, y: number, d: number) => void): void;
export declare function ellipse(bitmap: BITMAP | undefined, x: number, y: number, rx: number, ry: number, colour: number): void;
export declare function ellipsefill(bitmap: BITMAP | undefined, x: number, y: number, rx: number, ry: number, colour: number): void;
export declare function do_arc(bitmap: BITMAP | undefined, x: number, y: number, a1: number, a2: number, r: number, d: number, proc: (bmp: BITMAP, x: number, y: number, d: number) => void): void;
export declare function arc(bitmap: BITMAP | undefined, x: number, y: number, ang1: number, ang2: number, r: number, colour: number): void;
export declare function calc_spline(points: number[], npts: number, x: number, y: number): void;
export declare function spline(bmp: BITMAP | undefined, points: number[], color: number): void;
export declare function floodfill(bmp: BITMAP | undefined, x: number, y: number, color: number): void;
export declare function _fillstyle(bitmap: BITMAP | undefined, colour: number): void;
export declare function _strokestyle(bitmap: BITMAP | undefined, colour: number, width?: number): void;
