import { SAMPLE } from "./types";
export declare const digi_driver: {
    id: number;
    name: string;
    desc: string;
    ascii_name: string;
};
export declare const DIGI_AUTODETECT = -1;
export declare const DIGI_NONE = 0;
export declare const MIDI_AUTODETECT = -1;
export declare const MIDI_NONE = 0;
export declare const MIDI_DIGMID = 1;
export declare function install_sound(digi: number, midi: number, cfg_path?: string | null): number;
export declare function remove_sound(): void;
export declare function set_volume(digi_volume: number, midi_volume: number): void;
export declare function get_volume(): {
    digi_volume: number;
    midi_volume: number;
};
export declare function load_sample(filename: string): Promise<SAMPLE>;
export declare function destroy_sample(spl: SAMPLE): void;
export declare function play_sample(sample: SAMPLE, vol?: number, pan?: number, freq?: number, loop?: boolean): void;
export declare function adjust_sample(sample: SAMPLE, vol: number, pan: number, freq: number, loop: boolean): void;
export declare function stop_sample(sample: SAMPLE): void;
